#define NUM_COUNTERS 2048
#define COUNT_SHIFT  2
#define COUNT_MASK   0x7ff

#define NOT_A_BRANCH  0
#define COND_BRANCH   1
#define UNCOND_BRANCH 2
#define LIKELY_BRANCH 3  /* p32 of r12k manual - likely don't update predictor*/

void init_2bit();
int predict_2bit(unsigned int addr);
void update_2bit(unsigned int addr,int was_taken);
int get_branch_type(unsigned int insn);
int is_branch_forward(unsigned int insn);
